/* main.cpp

j2kaudio License 200707231230

Copyright (c) 2007 Gregory Alan Hildstrom

All rights reserved.

Permission is hereby granted, free of charge, to any person (the
"User") obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge,
publish, distribute, and/or sell copies of the Software, and to permit
persons to whom the Software is furnished to do so, subject to the
following conditions:

1.  The above copyright notices and this permission notice (which
includes the disclaimer below) shall be included in all copies or
substantial portions of the Software.

2.  The name of a copyright holder shall not be used to endorse or
promote products derived from the Software without specific prior
written permission.

THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF THIS
LICENSE.  NO USE OF THE SOFTWARE IS AUTHORIZED HEREUNDER EXCEPT UNDER
THIS DISCLAIMER.  THE SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS
"AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY RIGHTS.  IN NO
EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL
INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING
FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.  NO ASSURANCES ARE
PROVIDED BY THE COPYRIGHT HOLDERS THAT THE SOFTWARE DOES NOT INFRINGE
THE PATENT OR OTHER INTELLECTUAL PROPERTY RIGHTS OF ANY OTHER ENTITY.
EACH COPYRIGHT HOLDER DISCLAIMS ANY LIABILITY TO THE USER FOR CLAIMS
BROUGHT BY ANY OTHER ENTITY BASED ON INFRINGEMENT OF INTELLECTUAL
PROPERTY RIGHTS OR OTHERWISE.  AS A CONDITION TO EXERCISING THE RIGHTS
GRANTED HEREUNDER, EACH USER HEREBY ASSUMES SOLE RESPONSIBILITY TO SECURE
ANY OTHER INTELLECTUAL PROPERTY RIGHTS NEEDED, IF ANY.  THE SOFTWARE
IS NOT FAULT-TOLERANT AND IS NOT INTENDED FOR USE IN MISSION-CRITICAL
SYSTEMS, SUCH AS THOSE USED IN THE OPERATION OF NUCLEAR FACILITIES,
AIRCRAFT NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL
SYSTEMS, DIRECT LIFE SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH
THE FAILURE OF THE SOFTWARE OR SYSTEM COULD LEAD DIRECTLY TO DEATH,
PERSONAL INJURY, OR SEVERE PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH
RISK ACTIVITIES").  THE COPYRIGHT HOLDERS SPECIFICALLY DISCLAIM ANY
EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR HIGH RISK ACTIVITIES.

end of j2kaudio license

This example program uses j2kaudio to convert wav files to j2a and back.
Most of the variable names are pretty self-explanatory.
*/

#include "j2kaudio.h"

int main(int argc, char** argv){
	j2kaudio j2a;
	cout << "j2kaudio version: " << j2a.getversion() << endl;

	string temp,temp2;
	if(argc > 1)temp = argv[1];
	if(argc == 3)temp2 = argv[2];
	if(argc == 4){temp = argv[2];temp2 = argv[3];}
	if(argc == 4 && temp[temp.size()-3] == 'w' && temp[temp.size()-2] == 'a' && temp[temp.size()-1] == 'v' && temp2[temp2.size()-3] == 'j' && temp2[temp2.size()-2] == '2' && temp2[temp2.size()-1] == 'a'){
		j2a.setencodingrate((float)atof(argv[1]));
		while(j2a.readwav(argv[2])){
			j2a.compress();
			j2a.writej2a(argv[3]);
		}//end while
		j2a.closej2a();
	}//end if
	else if(argc == 3 && temp[temp.size()-3] == 'w' && temp[temp.size()-2] == 'a' && temp[temp.size()-1] == 'v'  && temp2[temp2.size()-3] == 'j' && temp2[temp2.size()-2] == '2' && temp2[temp2.size()-1] == 'a'){
		//lossless
		j2a.setencodingrate(1);
		while(j2a.readwav(argv[1])){
			j2a.compress();
			j2a.writej2a(argv[2]);
		}//end while
		j2a.closej2a();
	}//end if
	else if(argc == 3 && temp[temp.size()-3] == 'j' && temp[temp.size()-2] == '2' && temp[temp.size()-1] == 'a' && temp2[temp2.size()-3] == 'w' && temp2[temp2.size()-2] == 'a' && temp2[temp2.size()-1] == 'v'){
		while(j2a.readj2a(argv[1])){
			j2a.decompress();
			j2a.writewav(argv[2]);
		}//end while
		j2a.closewav(argv[2]);
	}//end else
	else if(argc == 2 && temp[temp.size()-3] == 'w' && temp[temp.size()-2] == 'a' && temp[temp.size()-1] == 'v'){
		temp2 = temp;
		temp2[temp2.size()-3] = 'j';
		temp2[temp2.size()-2] = '2';
		temp2[temp2.size()-1] = 'a';
		//lossless
		j2a.setencodingrate(1);
		while(j2a.readwav(argv[1])){
			j2a.compress();
			j2a.writej2a(temp2.data());
		}//end while
		j2a.closej2a();
	}//end if
	else if(argc == 2 && temp[temp.size()-3] == 'j' && temp[temp.size()-2] == '2' && temp[temp.size()-1] == 'a'){
		temp2 = temp;
		temp2[temp2.size()-3] = 'w';
		temp2[temp2.size()-2] = 'a';
		temp2[temp2.size()-1] = 'v';
		while(j2a.readj2a(argv[1])){
			j2a.decompress();
			j2a.writewav(temp2.data());
		}//end while
		j2a.closewav(argv[2]);
	}//end else
	else{
		cerr<< argv[0] << " reads in one .wav file and encodes it to a .j2a file and vice versa.\n"
		<< "Usage: " << argv[0] << " encodingrate infilename.wav outfilename.j2a\n"
		<< "Usage: " << argv[0] << " infilename.wav outfilename.j2a\n"
		<< "Usage: " << argv[0] << " infilename.j2a outfilename.wav\n"
		<< "Usage: " << argv[0] << " infilename.wav\n"
		<< "Usage: " << argv[0] << " infilename.j2a\n";
		exit(1);
	}//end else

	exit(0);
}//end main
